/*
 * Copyright IBM Corp. and others 1991
 *
 * This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License 2.0 which accompanies this
 * distribution and is available at https://www.eclipse.org/legal/epl-2.0/
 * or the Apache License, Version 2.0 which accompanies this distribution
 * and is available at https://www.apache.org/licenses/LICENSE-2.0.
 *
 * This Source Code may also be made available under the following
 * Secondary Licenses when the conditions for such availability set
 * forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
 * General Public License, version 2 with the GNU Classpath
 * Exception [1] and GNU General Public License, version 2 with the
 * OpenJDK Assembly Exception [2].
 *
 * [1] https://www.gnu.org/software/classpath/license.html
 * [2] https://openjdk.org/legal/assembly-exception.html
 *
 * SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0-only WITH Classpath-exception-2.0 OR GPL-2.0-only WITH OpenJDK-assembly-exception-1.0
 */

/**
 * WARNING!!! GENERATED FILE
 *
 * This class is generated.
 * Do not use the Eclipse "Organize Imports" feature on this class.
 *
 * It can contain user content, but that content must be delimited with the
 * the tags
 * [BEGIN USER IMPORTS]
 * [END USER IMPORTS]
 *
 * or
 *
 * [BEGIN USER CODE]
 * [END USER CODE]
 *
 * These tags are entered as comments.  Characters before [ and after ] are ignored.
 * Lines between the tags are inserted into the newly generated file.
 *
 * IMPORTS are combined and inserted above newly generated imports.  CODE is combined
 * and inserted immediately after the class declaration
 *
 * All lines outside these tags are lost and replaced with newly generated code.
 */
package com.ibm.j9ddr.vm29.pointer.generated;

/*[BEGIN USER IMPORTS]*/
/*[END USER IMPORTS]*/

import com.ibm.j9ddr.CorruptDataException;
import com.ibm.j9ddr.vm29.pointer.*;
import com.ibm.j9ddr.vm29.structure.*;
import com.ibm.j9ddr.vm29.types.*;

/**
 * Structure: EHExceptionRecord$EHParametersPointer
 *
 * A generated implementation of a VM structure
 *
 * This class contains generated code and MAY contain hand written user code.
 *
 * Hand written user code must be contained at the top of
 * the class file, specifically above
 * the comment line containing WARNING!!! GENERATED CODE
 *
 * ALL code below the GENERATED warning will be replaced with new generated code
 * each time the PointerGenerator utility is run.
 *
 * The generated code will provide getters for all elements in the EHExceptionRecord$EHParametersPointer
 * structure.  Where possible, meaningful return types are inferred.
 *
 * The user may add methods to provide meaningful return types where only pointers
 * could be automatically inferred.
 */
@com.ibm.j9ddr.GeneratedPointerClass(structureClass=EHExceptionRecord$EHParameters.class)
public class EHExceptionRecord$EHParametersPointer extends StructurePointer {

	// NULL
	public static final EHExceptionRecord$EHParametersPointer NULL = new EHExceptionRecord$EHParametersPointer(0);

/*[BEGIN USER CODE]*/
/*[END USER CODE]*/

	// Do not call this constructor.  Use static method cast instead.
	protected EHExceptionRecord$EHParametersPointer(long address) {
		super(address);
	}

	public static EHExceptionRecord$EHParametersPointer cast(AbstractPointer structure) {
		return cast(structure.getAddress());
	}

	public static EHExceptionRecord$EHParametersPointer cast(UDATA udata) {
		return cast(udata.longValue());
	}

	public static EHExceptionRecord$EHParametersPointer cast(long address) {
		if (address == 0) {
			return NULL;
		}
		return new EHExceptionRecord$EHParametersPointer(address);
	}

	public EHExceptionRecord$EHParametersPointer add(long count) {
		return EHExceptionRecord$EHParametersPointer.cast(address + (EHExceptionRecord$EHParameters.SIZEOF * count));
	}

	public EHExceptionRecord$EHParametersPointer add(Scalar count) {
		return add(count.longValue());
	}

	public EHExceptionRecord$EHParametersPointer addOffset(long offset) {
		return EHExceptionRecord$EHParametersPointer.cast(address + offset);
	}

	public EHExceptionRecord$EHParametersPointer addOffset(Scalar offset) {
		return addOffset(offset.longValue());
	}

	public EHExceptionRecord$EHParametersPointer sub(long count) {
		return EHExceptionRecord$EHParametersPointer.cast(address - (EHExceptionRecord$EHParameters.SIZEOF * count));
	}

	public EHExceptionRecord$EHParametersPointer sub(Scalar count) {
		return sub(count.longValue());
	}

	public EHExceptionRecord$EHParametersPointer subOffset(long offset) {
		return EHExceptionRecord$EHParametersPointer.cast(address - offset);
	}

	public EHExceptionRecord$EHParametersPointer subOffset(Scalar offset) {
		return subOffset(offset.longValue());
	}

	public EHExceptionRecord$EHParametersPointer untag(long mask) {
		return EHExceptionRecord$EHParametersPointer.cast(address & ~mask);
	}

	public EHExceptionRecord$EHParametersPointer untag() {
		return untag(UDATA.SIZEOF - 1);
	}

	protected long sizeOfBaseType() {
		return EHExceptionRecord$EHParameters.SIZEOF;
	}

	// Implementation methods

	// U32 magicNumber
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_magicNumberOffset_", declaredType="U32")
	public UDATA magicNumber() throws CorruptDataException {
		return new U32(getIntAtOffset(EHExceptionRecord$EHParameters._magicNumberOffset_));
	}

	// U32 magicNumber
	public UDATAPointer magicNumberEA() throws CorruptDataException {
		return UDATAPointer.cast(nonNullFieldEA(EHExceptionRecord$EHParameters._magicNumberOffset_));
	}

	// void* pExceptionObject
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_pExceptionObjectOffset_", declaredType="void*")
	public VoidPointer pExceptionObject() throws CorruptDataException {
		return VoidPointer.cast(getPointerAtOffset(EHExceptionRecord$EHParameters._pExceptionObjectOffset_));
	}

	// void* pExceptionObject
	public PointerPointer pExceptionObjectEA() throws CorruptDataException {
		return PointerPointer.cast(nonNullFieldEA(EHExceptionRecord$EHParameters._pExceptionObjectOffset_));
	}

	// void* pThrowImageBase
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_pThrowImageBaseOffset_", declaredType="void*")
	public VoidPointer pThrowImageBase() throws CorruptDataException {
		return VoidPointer.cast(getPointerAtOffset(EHExceptionRecord$EHParameters._pThrowImageBaseOffset_));
	}

	// void* pThrowImageBase
	public PointerPointer pThrowImageBaseEA() throws CorruptDataException {
		return PointerPointer.cast(nonNullFieldEA(EHExceptionRecord$EHParameters._pThrowImageBaseOffset_));
	}

	// const _s_ThrowInfo* pThrowInfo
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_pThrowInfoOffset_", declaredType="const _s_ThrowInfo*")
	public _s_ThrowInfoPointer pThrowInfo() throws CorruptDataException {
		return _s_ThrowInfoPointer.cast(getPointerAtOffset(EHExceptionRecord$EHParameters._pThrowInfoOffset_));
	}

	// const _s_ThrowInfo* pThrowInfo
	public PointerPointer pThrowInfoEA() throws CorruptDataException {
		return PointerPointer.cast(nonNullFieldEA(EHExceptionRecord$EHParameters._pThrowInfoOffset_));
	}

}
